from AST import ASTNode, getParseTreeNodes
from Environment import Env
from TheTypeNode import TypeNode, TypeStruct

#   LiteralNode
#   ParamNode

# maybe add a nameNode?
#################################################################################
# literals
class LiteralNode(ASTNode):
    toLiType = dict({
        'LITERALBOOL': 'boolean',
        'LITERALCHAR': 'char',
        'LITERALSTRING': 'java.lang.String',
        'NULL': 'null',
        'NUM': 'int',
        'ZERO': 'int'
    })
    # always list all fields in the init method to show the class structure
    def __init__(self, parseTree, typeName):
        self.parseTree = parseTree
        self.name = LiteralNode.toLiType.get(parseTree.children[0].name)  # type of the literal
        self.value = parseTree.children[0].lex # the value
        self.myType = TypeStruct(self.name, None)
        self.env = None
        self.children = []
        self.typeName = typeName

        if self.name == 'int':
            self.value = int(self.value)
        if self.name == 'LITERALBOOL':
            if self.value == 'false':
                self.value = False
            else:
                self.value = True

##################################################################################
# param type ID
class ParamNode(ASTNode):
    # always list all fields in the init method to show the class structure
    def __init__(self, parseTree, typeName):
        self.parseTree = parseTree
        self.paramType = TypeNode(parseTree.children[0], typeName)
        self.name = parseTree.children[1].lex
        self.env = None
        self.children = [self.paramType]
        self.typeName = typeName

    def checkType(self):
        self.myType = self.paramType.myType
